<?php

$header = <<<HEAD
<html>
<head>
<link rel="stylesheet" type="text/css" href="usage.css">
</head>
<body>
HEAD;

$footer = <<<FOOT
</table>
</body>
</html>
FOOT;


print $header;	


////////////////////////////////////////////
//                                        //
//           ROUTER #1                    //
//                                        //
///////////////////////////////////////////
//set the Gargoyle router configuration here
$router = 'http://192.168.0.1'; //Location of the Router webinterface
$pass = 'password'; //Router login password
$file = 'bandwidth.csv';

//grabs a file from the router using the PHP CURL library
$data="password=$pass";
$ch = curl_init();
//first use CURL to get the login cookie
curl_setopt($ch, CURLOPT_URL, $router."/utility/get_password_cookie.sh");
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11");
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 1);
$header = curl_exec ($ch);
//extract cookie string from header. Cookie starts at first "Set-Cookie" ocurrence
$p = strpos($header,'Set-Cookie');
//copy string from "Set-Cookie" to end of string
$cookie=substr($header,$p+11,strlen($header));
//remove unwanted stuff from cookie
$cookie = str_replace('Set-Cookie:','',$cookie);
$cookie = str_replace('Path=/;',' ',$cookie);
$cookie = str_replace(';','',$cookie);
$cookie = str_replace(' ','',$cookie);
//get the cookie information (hash and exp)
$hashStart = strpos($cookie,'hash=');
$expireDateStart = strpos($cookie,'exp=');
$hash = substr($cookie,$hashStart,69);//64 character hex plus 5 characters for 'hash=' string
$expire = substr($cookie,$expireDateStart,14);//Length of plus 4 characters for 'exp=' string
//join the cookie information in a valid cookie string for CURLOPT_COOKIE parameter.
$cookie = $hash.'; '.$expire;
//Grab the requested file from the router
curl_setopt($ch, CURLOPT_URL, $router."/".$file);
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11");
curl_setopt($ch, CURLOPT_POST, false);
curl_setopt($ch, CURLOPT_COOKIE, $cookie);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 1);
$html = curl_exec($ch);
curl_close($ch);

//verify if the resulting html is valid by checking if some part of the html in the login form exists.
if (strpos($html, "id='password_label'") === FALSE) {
	//login OK, the output should be the CSV so let's convert the output to an array (each line of the CSV is one element)
	$html=nl2br($html);
	$lines = explode('<br />',$html);
	//return the array of lines
	//var_dump($lines);
	//return $lines;
} //else {
	//login form found means the login process didn't work, let's return FALSE.
	//return false;
//}

$usage1 = array();
$upload = array();
//find monthly download usage
foreach ($lines as $key => $value) {
	if(substr_count($value, 'download,month,12') > 0) {
		$temp[$key] = explode(",", $value);
		$logmonth = date('n', $temp[$key][4]);
		$today = getdate();
		if($today[mon] == $logmonth) {
			$usage1[] = explode(",", $value);
		}
	}
}

//find monthly upload usage
foreach ($lines as $key => $value) {
	if(substr_count($value, 'upload,month,12') > 0) {
		$temp[$key] = explode(",", $value);
		$logmonth = date('n', $temp[$key][4]);
		$today = getdate();
		if($today[mon] == $logmonth) {
			$upload[] = explode(",", $value);
		}
	}
}

//move upload info into the storage array
foreach ($upload as $value) {
	foreach ($usage1 as $key => $val) {
		if ($val[3] == $value[3]) {
			$usage1[$key][7] = $value[6];
		}
	}
}

// search for hostname from dhcp server 
$file = file('/etc/dhcp/dhcpd.conf');
foreach ($usage1 as $key => $value) {
	$search = 'fixed-address '.$value[3].';';
	foreach($file as $num => $line) {
		if(strpos($line, 'host ') !== false) {
		 	if(strpos($file[$num+1], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} elseif (strpos($file[$num+2], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} elseif (strpos($file[$num+3], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} elseif (strpos($file[$num+4], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			}
		}

	}
}

$table = <<<TABLE
GATEWAY #1
<table>
<tr>
<th>Address:</th>
<th>Download(MB):</th>
<th>Upload(MB):</th>
<th>Total(MB):</th>
<th>Machine:</th>
<th>&nbsp</th>
</tr>
<tr>
TABLE;

echo $table;

foreach ($usage1 as $value) {
	$downMB = $value[6]/1024/1024;
	$upMB = $value[7]/1024/1024;
	$totalMB = $downMB + $upMB;
	echo '<td>'.$value[3].'</td>';
	echo '<td align="right">'.number_format("$downMB",2).'</td>';
	echo '<td align="right">'.number_format("$upMB",2).'</td>';
	echo '<td align="right">'.number_format("$totalMB",2).'</td>';
	echo '<td>'.$value[8].'</td>';
	echo '<td style="width:12px"><a href="chart.php?router=192.168.0.1&name='.$value[8].'&ip='.$value[3].'"><img src="libchart/images/chart.gif"></a></td></tr>'; 
}
echo '</table>';



////////////////////////////////////////////
//                                        //
//           ROUTER #2                    //
//                                        //
///////////////////////////////////////////
//set the Gargoyle router configuration here
$router = 'http://192.168.0.2'; //Location of the Router webinterface
$pass = 'password'; //Router login password
$file = 'bandwidth.csv';

//grabs a file from the router using the PHP CURL library
$data="password=$pass";
$ch = curl_init();
//first use CURL to get the login cookie
curl_setopt($ch, CURLOPT_URL, $router."/utility/get_password_cookie.sh");
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11");
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 1);
$header = curl_exec ($ch);
//extract cookie string from header. Cookie starts at first "Set-Cookie" ocurrence
$p = strpos($header,'Set-Cookie');
//copy string from "Set-Cookie" to end of string
$cookie=substr($header,$p+11,strlen($header));
//remove unwanted stuff from cookie
$cookie = str_replace('Set-Cookie:','',$cookie);
$cookie = str_replace('Path=/;',' ',$cookie);
$cookie = str_replace(';','',$cookie);
$cookie = str_replace(' ','',$cookie);
//get the cookie information (hash and exp)
$hashStart = strpos($cookie,'hash=');
$expireDateStart = strpos($cookie,'exp=');
$hash = substr($cookie,$hashStart,69);//64 character hex plus 5 characters for 'hash=' string
$expire = substr($cookie,$expireDateStart,14);//Length of plus 4 characters for 'exp=' string
//join the cookie information in a valid cookie string for CURLOPT_COOKIE parameter.
$cookie = $hash.'; '.$expire;
//Grab the requested file from the router
curl_setopt($ch, CURLOPT_URL, $router."/".$file);
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11");
curl_setopt($ch, CURLOPT_POST, false);
curl_setopt($ch, CURLOPT_COOKIE, $cookie);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 1);
$html = curl_exec($ch);
curl_close($ch);

//verify if the resulting html is valid by checking if some part of the html in the login form exists.
if (strpos($html, "id='password_label'") === FALSE) {
	//login OK, the output should be the CSV so let's convert the output to an array (each line of the CSV is one element)
	$html=nl2br($html);
	$lines = explode('<br />',$html);
	//return the array of lines
	//var_dump($lines);
	//return $lines;
} //else {
	//login form found means the login process didn't work, let's return FALSE.
	//return false;
//}

$usage1 = array();
$upload = array();

//find monthly download usage
foreach ($lines as $key => $value) {
	if(substr_count($value, 'download,month,12') > 0) {
		$temp[$key] = explode(",", $value);
		$logmonth = date('n', $temp[$key][4]);
		$today = getdate();
		if($today[mon] == $logmonth) {
			$usage1[] = explode(",", $value);
		}
	}
}

//find monthly upload usage
foreach ($lines as $key => $value) {
	if(substr_count($value, 'upload,month,12') > 0) {
		$temp[$key] = explode(",", $value);
		$logmonth = date('n', $temp[$key][4]);
		$today = getdate();
		if($today[mon] == $logmonth) {
			$upload[] = explode(",", $value);
		}
	}
}

//move upload info into the storage array
foreach ($upload as $value) {
	foreach ($usage1 as $key => $val) {
		if ($val[3] == $value[3]) {
			$usage1[$key][7] = $value[6];
		}
	}
}

// search for hostname from dhcp server 
$file = file('/etc/dhcp/dhcpd.conf');
foreach ($usage1 as $key => $value) {
	$search = 'fixed-address '.$value[3].';';
	foreach($file as $num => $line) {
		if(strpos($line, 'host') !== false) {
		 	if(strpos($file[$num+1], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} elseif (strpos($file[$num+2], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} elseif (strpos($file[$num+3], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} else {} 
		}

	}
}

$table = <<<TABLE
<br>
GATEWAY #2
<table>
<tr>
<th>Address:</th>
<th>Download(MB):</th>
<th>Upload(MB):</th>
<th>Total(MB):</th>
<th>Machine:</th>
<th>&nbsp</th>
</tr>
<tr>
TABLE;

echo $table;

foreach ($usage1 as $value) {
	$downMB = $value[6]/1024/1024;
	$upMB = $value[7]/1024/1024;
	$totalMB = $downMB + $upMB;
	echo '<td>'.$value[3].'</td>';
	echo '<td align="right">'.number_format("$downMB",2).'</td>';
	echo '<td align="right">'.number_format("$upMB",2).'</td>';
	echo '<td align="right">'.number_format("$totalMB",2).'</td>';
	echo '<td>'.$value[8].'</td>';
	echo '<td style="width:12px"><a href="chart.php?router=192.168.0.2&name='.$value[8].'&ip='.$value[3].'"><img src="libchart/images/chart.gif"></a></td></tr>'; 
}
echo '</table>';










////////////////////////////////////////////
//                                        //
//           ROUTER #3                    //
//                                        //
///////////////////////////////////////////
//set the Gargoyle router configuration here
$router = 'http://192.168.0.3'; //Location of the Router webinterface
$pass = 'password'; //Router login password
$file = 'bandwidth.csv';

//grabs a file from the router using the PHP CURL library
$data="password=$pass";
$ch = curl_init();
//first use CURL to get the login cookie
curl_setopt($ch, CURLOPT_URL, $router."/utility/get_password_cookie.sh");
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11");
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 1);
$header = curl_exec ($ch);
//extract cookie string from header. Cookie starts at first "Set-Cookie" ocurrence
$p = strpos($header,'Set-Cookie');
//copy string from "Set-Cookie" to end of string
$cookie=substr($header,$p+11,strlen($header));
//remove unwanted stuff from cookie
$cookie = str_replace('Set-Cookie:','',$cookie);
$cookie = str_replace('Path=/;',' ',$cookie);
$cookie = str_replace(';','',$cookie);
$cookie = str_replace(' ','',$cookie);
//get the cookie information (hash and exp)
$hashStart = strpos($cookie,'hash=');
$expireDateStart = strpos($cookie,'exp=');
$hash = substr($cookie,$hashStart,69);//64 character hex plus 5 characters for 'hash=' string
$expire = substr($cookie,$expireDateStart,14);//Length of plus 4 characters for 'exp=' string
//join the cookie information in a valid cookie string for CURLOPT_COOKIE parameter.
$cookie = $hash.'; '.$expire;
//Grab the requested file from the router
curl_setopt($ch, CURLOPT_URL, $router."/".$file);
curl_setopt($ch, CURLOPT_REFERER, $router.'/login.sh');
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/536.11 (KHTML, like Gecko) Chrome/20.0.1132.47 Safari/536.11");
curl_setopt($ch, CURLOPT_POST, false);
curl_setopt($ch, CURLOPT_COOKIE, $cookie);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_HEADER, 1);
$html = curl_exec($ch);
curl_close($ch);

//verify if the resulting html is valid by checking if some part of the html in the login form exists.
if (strpos($html, "id='password_label'") === FALSE) {
	//login OK, the output should be the CSV so let's convert the output to an array (each line of the CSV is one element)
	$html=nl2br($html);
	$lines = explode('<br />',$html);
	//return the array of lines
	//var_dump($lines);
	//return $lines;
} //else {
	//login form found means the login process didn't work, let's return FALSE.
	//return false;
//}

$usage1 = array();
$upload = array();

//find monthly download usage
foreach ($lines as $key => $value) {
	if(substr_count($value, 'download,month,12') > 0) {
		$temp[$key] = explode(",", $value);
		$logmonth = date('n', $temp[$key][4]);
		$today = getdate();
		if($today[mon] == $logmonth) {
			$usage1[] = explode(",", $value);
		}
	}
}

//find monthly upload usage
foreach ($lines as $key => $value) {
	if(substr_count($value, 'upload,month,12') > 0) {
		$temp[$key] = explode(",", $value);
		$logmonth = date('n', $temp[$key][4]);
		$today = getdate();
		if($today[mon] == $logmonth) {
			$upload[] = explode(",", $value);
		}
	}
}

//move upload info into the storage array
foreach ($upload as $value) {
	foreach ($usage1 as $key => $val) {
		if ($val[3] == $value[3]) {
			$usage1[$key][7] = $value[6];
		}
	}
}

// search for hostname from dhcp server 
$file = file('/etc/dhcp/dhcpd.conf');
foreach ($usage1 as $key => $value) {
	$search = 'fixed-address '.$value[3].';';
	foreach($file as $num => $line) {
		if(strpos($line, 'host') !== false) {
		 	if(strpos($file[$num+1], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} elseif (strpos($file[$num+2], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} elseif (strpos($file[$num+3], $search) !== false) {
				$name = substr($line, 5, -2);
				$usage1[$key][8] = $name;
			} else {} 
		}

	}
}

$table = <<<TABLE
<br>
GATEWAY #3  MIFI1
<table>
<tr>
<th>Address:</th>
<th>Download(MB):</th>
<th>Upload(MB):</th>
<th>Total(MB):</th>
<th>Machine:</th>
<th>&nbsp</th>
</tr>
<tr>
TABLE;

echo $table;

foreach ($usage1 as $value) {
	$downMB = $value[6]/1024/1024;
	$upMB = $value[7]/1024/1024;
	$totalMB = $downMB + $upMB;
	echo '<td>'.$value[3].'</td>';
	echo '<td align="right">'.number_format("$downMB",2).'</td>';
	echo '<td align="right">'.number_format("$upMB",2).'</td>';
	echo '<td align="right">'.number_format("$totalMB",2).'</td>';
	echo '<td>'.$value[8].'</td>';
	echo '<td style="width:12px"><a href="chart.php?router=192.168.0.3&name='.$value[8].'&ip='.$value[3].'"><img src="libchart/images/chart.gif"></a></td></tr>'; 
}
echo '</table>';



print $footer;


?>
